diff --git a/contrib/gmm/gmm_matrix.h b/contrib/gmm/gmm_matrix.h
index 09946f09e5..771a246f45 100644
--- a/contrib/gmm/gmm_matrix.h
+++ b/contrib/gmm/gmm_matrix.h
@@ -1,32 +1,33 @@
-// -*- c++ -*- (enables emacs c++ mode)
-//===========================================================================
-//
-// Copyright (C) 2002-2008 Yves Renard
-//
-// This file is a part of GETFEM++
-//
-// Getfem++  is  free software;  you  can  redistribute  it  and/or modify it
-// under  the  terms  of the  GNU  Lesser General Public License as published
-// by  the  Free Software Foundation;  either version 2.1 of the License,  or
-// (at your option) any later version.
-// This program  is  distributed  in  the  hope  that it will be useful,  but
-// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
-// or  FITNESS  FOR  A PARTICULAR PURPOSE.  See the GNU Lesser General Public
-// License for more details.
-// You  should  have received a copy of the GNU Lesser General Public License
-// along  with  this program;  if not, write to the Free Software Foundation,
-// Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA.
-//
-// As a special exception, you may use this file as part of a free software
-// library without restriction.  Specifically, if other files instantiate
-// templates or use macros or inline functions from this file, or you compile
-// this file and link it with other files to produce an executable, this
-// file does not by itself cause the resulting executable to be covered by
-// the GNU General Public License.  This exception does not however
-// invalidate any other reasons why the executable file might be covered by
-// the GNU General Public License.
-//
-//===========================================================================
+/* -*- c++ -*- (enables emacs c++ mode) */
+/*===========================================================================
+
+ Copyright (C) 2002-2020 Yves Renard
+
+ This file is a part of GetFEM
+
+ GetFEM  is  free software;  you  can  redistribute  it  and/or modify it
+ under  the  terms  of the  GNU  Lesser General Public License as published
+ by  the  Free Software Foundation;  either version 3 of the License,  or
+ (at your option) any later version along with the GCC Runtime Library
+ Exception either version 3.1 or (at your option) any later version.
+ This program  is  distributed  in  the  hope  that it will be useful,  but
+ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
+ or  FITNESS  FOR  A PARTICULAR PURPOSE.  See the GNU Lesser General Public
+ License and GCC Runtime Library Exception for more details.
+ You  should  have received a copy of the GNU Lesser General Public License
+ along  with  this program;  if not, write to the Free Software Foundation,
+ Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA.
+
+ As a special exception, you  may use  this file  as it is a part of a free
+ software  library  without  restriction.  Specifically,  if   other  files
+ instantiate  templates  or  use macros or inline functions from this file,
+ or  you compile this  file  and  link  it  with other files  to produce an
+ executable, this file  does  not  by itself cause the resulting executable
+ to be covered  by the GNU Lesser General Public License.  This   exception
+ does not  however  invalidate  any  other  reasons why the executable file
+ might be covered by the GNU Lesser General Public License.
+
+===========================================================================*/
 
 /** @file gmm_matrix.h
    @author  Yves Renard <Yves.Renard@insa-lyon.fr>
@@ -47,9 +48,9 @@ namespace gmm
 {
 
   /* ******************************************************************** */
-  /*		                                            		  */
-  /*		Identity matrix                         		  */
-  /*		                                            		  */
+  /*                                                                      */
+  /*            Identity matrix                                           */
+  /*                                                                      */
   /* ******************************************************************** */
 
   struct identity_matrix {
@@ -63,14 +64,14 @@ namespace gmm
       v1(i,i) += typename linalg_traits<M>::value_type(1);
   }
   template <typename M> inline
-  void add(const identity_matrix &I, const M &v1)
-  { add(I, linalg_const_cast(v1)); }
+  void add(const identity_matrix &II, const M &v1)
+  { add(II, linalg_const_cast(v1)); }
 
   template <typename V1, typename V2> inline
   void mult(const identity_matrix&, const V1 &v1, V2 &v2)
   { copy(v1, v2); }
   template <typename V1, typename V2> inline
-  void mult(const identity_matrix&, const V1 &v1, const V2 &v2) 
+  void mult(const identity_matrix&, const V1 &v1, const V2 &v2)
   { copy(v1, v2); }
   template <typename V1, typename V2, typename V3> inline
   void mult(const identity_matrix&, const V1 &v1, const V2 &v2, V3 &v3)
@@ -82,25 +83,25 @@ namespace gmm
   void left_mult(const identity_matrix&, const V1 &v1, V2 &v2)
   { copy(v1, v2); }
   template <typename V1, typename V2> inline
-  void left_mult(const identity_matrix&, const V1 &v1, const V2 &v2) 
+  void left_mult(const identity_matrix&, const V1 &v1, const V2 &v2)
   { copy(v1, v2); }
   template <typename V1, typename V2> inline
   void right_mult(const identity_matrix&, const V1 &v1, V2 &v2)
   { copy(v1, v2); }
   template <typename V1, typename V2> inline
-  void right_mult(const identity_matrix&, const V1 &v1, const V2 &v2) 
+  void right_mult(const identity_matrix&, const V1 &v1, const V2 &v2)
   { copy(v1, v2); }
   template <typename V1, typename V2> inline
   void transposed_left_mult(const identity_matrix&, const V1 &v1, V2 &v2)
   { copy(v1, v2); }
   template <typename V1, typename V2> inline
-  void transposed_left_mult(const identity_matrix&, const V1 &v1,const V2 &v2) 
+  void transposed_left_mult(const identity_matrix&, const V1 &v1,const V2 &v2)
   { copy(v1, v2); }
   template <typename V1, typename V2> inline
   void transposed_right_mult(const identity_matrix&, const V1 &v1, V2 &v2)
   { copy(v1, v2); }
   template <typename V1, typename V2> inline
-  void transposed_right_mult(const identity_matrix&,const V1 &v1,const V2 &v2) 
+  void transposed_right_mult(const identity_matrix&,const V1 &v1,const V2 &v2)
   { copy(v1, v2); }
   template <typename M> void copy_ident(const identity_matrix&, M &m) {
     size_type i = 0, n = std::min(mat_nrows(m), mat_ncols(m));
@@ -108,7 +109,7 @@ namespace gmm
     for (; i < n; ++i) m(i,i) = typename linalg_traits<M>::value_type(1);
   }
   template <typename M> inline void copy(const identity_matrix&, M &m)
-  { copy_ident(identity_matrix(), m); } 
+  { copy_ident(identity_matrix(), m); }
   template <typename M> inline void copy(const identity_matrix &, const M &m)
   { copy_ident(identity_matrix(), linalg_const_cast(m)); }
   template <typename V1, typename V2> inline
@@ -123,24 +124,24 @@ namespace gmm
   inline bool is_identity(const identity_matrix&) { return true; }
 
   /* ******************************************************************** */
-  /*		                                            		  */
-  /*		Row matrix                                   		  */
-  /*		                                            		  */
+  /*                                                                      */
+  /*            Row matrix                                                */
+  /*                                                                      */
   /* ******************************************************************** */
 
   template<typename V> class row_matrix {
   protected :
     std::vector<V> li; /* array of rows.                                  */
     size_type nc;
-    
+
   public :
-    
+
     typedef typename linalg_traits<V>::reference reference;
     typedef typename linalg_traits<V>::value_type value_type;
-    
+
     row_matrix(size_type r, size_type c) : li(r, V(c)), nc(c) {}
     row_matrix(void) : nc(0) {}
-    reference operator ()(size_type l, size_type c) 
+    reference operator ()(size_type l, size_type c)
     { return li[l][c]; }
     value_type operator ()(size_type l, size_type c) const
     { return li[l][c]; }
@@ -150,19 +151,19 @@ namespace gmm
 
     typename std::vector<V>::iterator begin(void)
     { return li.begin(); }
-    typename std::vector<V>::iterator end(void)  
+    typename std::vector<V>::iterator end(void)
     { return li.end(); }
     typename std::vector<V>::const_iterator begin(void) const
     { return li.begin(); }
     typename std::vector<V>::const_iterator end(void) const
     { return li.end(); }
-    
-    
+
+
     V& row(size_type i) { return li[i]; }
     const V& row(size_type i) const { return li[i]; }
     V& operator[](size_type i) { return li[i]; }
     const V& operator[](size_type i) const { return li[i]; }
-    
+
     inline size_type nrows(void) const { return li.size(); }
     inline size_type ncols(void) const { return nc;        }
 
@@ -171,9 +172,13 @@ namespace gmm
   };
 
   template<typename V> void row_matrix<V>::resize(size_type m, size_type n) {
+    size_type nr = std::min(nrows(), m);
     li.resize(m);
-    for (size_type i=0; i < m; ++i) gmm::resize(li[i], n);
-    nc = n;
+    for (size_type i=nr; i < m; ++i) gmm::resize(li[i], n);
+    if (n != nc) {
+      for (size_type i=0; i < nr; ++i) gmm::resize(li[i], n);
+      nc = n;
+    }
   }
 
 
@@ -188,8 +193,8 @@ namespace gmm
     typedef typename linalg_traits<V>::value_type value_type;
     typedef typename linalg_traits<V>::reference reference;
     typedef typename linalg_traits<V>::storage_type storage_type;
-    typedef simple_vector_ref<V *> sub_row_type;
-    typedef simple_vector_ref<const V *> const_sub_row_type;
+    typedef V & sub_row_type;
+    typedef const V & const_sub_row_type;
     typedef typename std::vector<V>::iterator row_iterator;
     typedef typename std::vector<V>::const_iterator const_row_iterator;
     typedef abstract_null_type sub_col_type;
@@ -208,7 +213,7 @@ namespace gmm
     { return m.end(); }
     static const_sub_row_type row(const const_row_iterator &it)
     { return const_sub_row_type(*it); }
-    static sub_row_type row(const row_iterator &it) 
+    static sub_row_type row(const row_iterator &it)
     { return sub_row_type(*it); }
     static origin_type* origin(this_type &m) { return &m; }
     static const origin_type* origin(const this_type &m) { return &m; }
@@ -227,21 +232,21 @@ namespace gmm
     (std::ostream &o, const row_matrix<V>& m) { gmm::write(o,m); return o; }
 
   /* ******************************************************************** */
-  /*		                                            		  */
-  /*		Column matrix                                		  */
-  /*		                                            		  */
+  /*                                                                      */
+  /*            Column matrix                                             */
+  /*                                                                      */
   /* ******************************************************************** */
 
   template<typename V> class col_matrix {
   protected :
     std::vector<V> li; /* array of columns.                               */
     size_type nr;
-    
+
   public :
-    
+
     typedef typename linalg_traits<V>::reference reference;
     typedef typename linalg_traits<V>::value_type value_type;
-    
+
     col_matrix(size_type r, size_type c) : li(c, V(r)), nr(r) { }
     col_matrix(void) : nr(0) {}
     reference operator ()(size_type l, size_type c)
@@ -259,13 +264,13 @@ namespace gmm
 
     typename std::vector<V>::iterator begin(void)
     { return li.begin(); }
-    typename std::vector<V>::iterator end(void)  
+    typename std::vector<V>::iterator end(void)
     { return li.end(); }
     typename std::vector<V>::const_iterator begin(void) const
     { return li.begin(); }
     typename std::vector<V>::const_iterator end(void) const
     { return li.end(); }
-    
+
     inline size_type ncols(void) const { return li.size(); }
     inline size_type nrows(void) const { return nr; }
 
@@ -274,9 +279,13 @@ namespace gmm
   };
 
   template<typename V> void col_matrix<V>::resize(size_type m, size_type n) {
+    size_type nc = std::min(ncols(), n);
     li.resize(n);
-    for (size_type i=0; i < n; ++i) gmm::resize(li[i], m);
-    nr = m;
+    for (size_type i=nc; i < n; ++i) gmm::resize(li[i], m);
+    if (m != nr) {
+      for (size_type i=0; i < nc; ++i) gmm::resize(li[i], m);
+      nr = m;
+    }
   }
 
   template<typename V> void col_matrix<V>::clear_mat()
@@ -290,8 +299,8 @@ namespace gmm
     typedef typename linalg_traits<V>::value_type value_type;
     typedef typename linalg_traits<V>::reference reference;
     typedef typename linalg_traits<V>::storage_type storage_type;
-    typedef simple_vector_ref<V *> sub_col_type;
-    typedef simple_vector_ref<const V *> const_sub_col_type;
+    typedef V &sub_col_type;
+    typedef const V &const_sub_col_type;
     typedef typename std::vector<V>::iterator col_iterator;
     typedef typename std::vector<V>::const_iterator const_col_iterator;
     typedef abstract_null_type sub_row_type;
@@ -309,9 +318,9 @@ namespace gmm
     static const_col_iterator col_end(const this_type &m)
     { return m.end(); }
     static const_sub_col_type col(const const_col_iterator &it)
-    { return const_sub_col_type(*it); }
-    static sub_col_type col(const col_iterator &it) 
-    { return sub_col_type(*it); }
+    { return *it; }
+    static sub_col_type col(const col_iterator &it)
+    { return *it; }
     static origin_type* origin(this_type &m) { return &m; }
     static const origin_type* origin(const this_type &m) { return &m; }
     static void do_clear(this_type &m) { m.clear_mat(); }
@@ -329,9 +338,9 @@ namespace gmm
     (std::ostream &o, const col_matrix<V>& m) { gmm::write(o,m); return o; }
 
   /* ******************************************************************** */
-  /*		                                            		  */
-  /*		Dense matrix                                		  */
-  /*		                                            		  */
+  /*                                                                      */
+  /*            Dense matrix                                              */
+  /*                                                                      */
   /* ******************************************************************** */
 
   template<typename T> class dense_matrix : public std::vector<T> {
@@ -339,30 +348,36 @@ namespace gmm
     typedef typename std::vector<T>::size_type size_type;
     typedef typename std::vector<T>::iterator iterator;
     typedef typename std::vector<T>::const_iterator const_iterator;
-    
+    typedef typename std::vector<T>::reference reference;
+    typedef typename std::vector<T>::const_reference const_reference;
+
   protected:
     size_type nbc, nbl;
-    
+
   public:
-    
-    inline const T& operator ()(size_type l, size_type c) const {
+
+    inline const_reference operator ()(size_type l, size_type c) const {
       GMM_ASSERT2(l < nbl && c < nbc, "out of range");
       return *(this->begin() + c*nbl+l);
     }
-    inline T& operator ()(size_type l, size_type c) {
+    inline reference operator ()(size_type l, size_type c) {
       GMM_ASSERT2(l < nbl && c < nbc, "out of range");
       return *(this->begin() + c*nbl+l);
     }
 
+    std::vector<T> &as_vector(void) { return *this; }
+    const std::vector<T> &as_vector(void) const { return *this; }
+
     void resize(size_type, size_type);
+    void base_resize(size_type, size_type);
     void reshape(size_type, size_type);
-    
+
     void fill(T a, T b = T(0));
     inline size_type nrows(void) const { return nbl; }
     inline size_type ncols(void) const { return nbc; }
     void swap(dense_matrix<T> &m)
     { std::vector<T>::swap(m); std::swap(nbc, m.nbc); std::swap(nbl, m.nbl); }
-    
+
     dense_matrix(size_type l, size_type c)
       : std::vector<T>(c*l), nbc(c), nbl(l)  {}
     dense_matrix(void) { nbl = nbc = 0; }
@@ -373,30 +388,34 @@ namespace gmm
     nbl = m; nbc = n;
   }
 
+  template<typename T> void dense_matrix<T>::base_resize(size_type m,
+                                                         size_type n)
+  { std::vector<T>::resize(n*m); nbl = m; nbc = n; }
+
   template<typename T> void dense_matrix<T>::resize(size_type m, size_type n) {
     if (n*m > nbc*nbl) std::vector<T>::resize(n*m);
     if (m < nbl) {
       for (size_type i = 1; i < std::min(nbc, n); ++i)
-	std::copy(this->begin()+i*nbl, this->begin()+(i*nbl+m),
-		  this->begin()+i*m);
+        std::copy(this->begin()+i*nbl, this->begin()+(i*nbl+m),
+                  this->begin()+i*m);
       for (size_type i = std::min(nbc, n); i < n; ++i)
-	std::fill(this->begin()+(i*m), this->begin()+(i+1)*m, T(0));
+        std::fill(this->begin()+(i*m), this->begin()+(i+1)*m, T(0));
       }
     else if (m > nbl) { /* do nothing when the nb of rows does not change */
       for (size_type i = std::min(nbc, n); i > 1; --i)
-	std::copy(this->begin()+(i-1)*nbl, this->begin()+i*nbl,
-		  this->begin()+(i-1)*m);
+        std::copy(this->begin()+(i-1)*nbl, this->begin()+i*nbl,
+                  this->begin()+(i-1)*m);
       for (size_type i = 0; i < std::min(nbc, n); ++i)
-	std::fill(this->begin()+(i*m+nbl), this->begin()+(i+1)*m, T(0));
+        std::fill(this->begin()+(i*m+nbl), this->begin()+(i+1)*m, T(0));
     }
     if (n*m < nbc*nbl) std::vector<T>::resize(n*m);
     nbl = m; nbc = n;
   }
-  
+
   template<typename T> void dense_matrix<T>::fill(T a, T b) {
     std::fill(this->begin(), this->end(), b);
     size_type n = std::min(nbl, nbc);
-    if (a != b) for (size_type i = 0; i < n; ++i) (*this)(i,i) = a; 
+    if (a != b) for (size_type i = 0; i < n; ++i) (*this)(i,i) = a;
   }
 
   template <typename T> struct linalg_traits<dense_matrix<T> > {
@@ -408,25 +427,25 @@ namespace gmm
     typedef T& reference;
     typedef abstract_dense storage_type;
     typedef tab_ref_reg_spaced_with_origin<typename this_type::iterator,
-					   this_type> sub_row_type;
+                                           this_type> sub_row_type;
     typedef tab_ref_reg_spaced_with_origin<typename this_type::const_iterator,
-					   this_type> const_sub_row_type;
+                                           this_type> const_sub_row_type;
     typedef dense_compressed_iterator<typename this_type::iterator,
-				      typename this_type::iterator,
-				      this_type *> row_iterator;
+                                      typename this_type::iterator,
+                                      this_type *> row_iterator;
     typedef dense_compressed_iterator<typename this_type::const_iterator,
-				      typename this_type::iterator,
-				      const this_type *> const_row_iterator;
-    typedef tab_ref_with_origin<typename this_type::iterator, 
-				this_type> sub_col_type;
+                                      typename this_type::iterator,
+                                      const this_type *> const_row_iterator;
+    typedef tab_ref_with_origin<typename this_type::iterator,
+                                this_type> sub_col_type;
     typedef tab_ref_with_origin<typename this_type::const_iterator,
-				this_type> const_sub_col_type;
+                                this_type> const_sub_col_type;
     typedef dense_compressed_iterator<typename this_type::iterator,
-				      typename this_type::iterator,
-				      this_type *> col_iterator;
+                                      typename this_type::iterator,
+                                      this_type *> col_iterator;
     typedef dense_compressed_iterator<typename this_type::const_iterator,
-				      typename this_type::iterator,
-				      const this_type *> const_col_iterator;
+                                      typename this_type::iterator,
+                                      const this_type *> const_col_iterator;
     typedef col_and_row sub_orientation;
     typedef linalg_true index_sorted;
     static size_type nrows(const this_type &m) { return m.nrows(); }
@@ -471,19 +490,19 @@ namespace gmm
   template<typename T> std::ostream &operator <<
     (std::ostream &o, const dense_matrix<T>& m) { gmm::write(o,m); return o; }
 
+
   /* ******************************************************************** */
   /*                                                                      */
-  /*	        Read only compressed sparse column matrix                 */
+  /*             Read only compressed sparse column matrix                */
   /*                                                                      */
   /* ******************************************************************** */
 
-  template <typename T, int shift = 0>
+  template <typename T, typename IND_TYPE = unsigned int, int shift = 0>
   struct csc_matrix {
-    typedef unsigned int IND_TYPE;
 
-    T *pr;        // values.
-    IND_TYPE *ir; // row indices.
-    IND_TYPE *jc; // column repartition on pr and ir.
+    std::vector<T> pr;
+    std::vector<IND_TYPE> ir;
+    std::vector<IND_TYPE> jc;
     size_type nc, nr;
 
     typedef T value_type;
@@ -498,79 +517,75 @@ namespace gmm
     template <typename PT1, typename PT2, typename PT3, int cshift>
     void init_with(const csc_matrix_ref<PT1,PT2,PT3,cshift>& B)
     { init_with_good_format(B); }
-    template <typename U, int cshift>    
-    void init_with(const csc_matrix<U, cshift>& B)
+    template <typename U, int cshift>
+    void init_with(const csc_matrix<U, IND_TYPE, cshift>& B)
     { init_with_good_format(B); }
 
     void init_with_identity(size_type n);
 
-    csc_matrix(void) : pr(0), ir(0), jc(0), nc(0), nr(0) {}
+    csc_matrix(void) :  nc(0), nr(0) {}
     csc_matrix(size_type nnr, size_type nnc);
-    ~csc_matrix() { if (pr) { delete[] pr; delete[] ir; delete[] jc; } }
 
     size_type nrows(void) const { return nr; }
     size_type ncols(void) const { return nc; }
-    void swap(csc_matrix<T, shift> &m) { 
-      std::swap(pr, m.pr); 
-      std::swap(ir,m.ir); std::swap(jc, m.jc); 
-      std::swap(nc, m.nc); std::swap(nr,m.nr);
+    void swap(csc_matrix<T, IND_TYPE, shift> &m) {
+      std::swap(pr, m.pr);
+      std::swap(ir, m.ir); std::swap(jc, m.jc);
+      std::swap(nc, m.nc); std::swap(nr, m.nr);
     }
     value_type operator()(size_type i, size_type j) const
     { return mat_col(*this, j)[i]; }
   };
 
-  template <typename T, int shift> template<typename Matrix>
-  void csc_matrix<T, shift>::init_with_good_format(const Matrix &B) {
+  template <typename T, typename IND_TYPE, int shift> template<typename Matrix>
+  void csc_matrix<T, IND_TYPE, shift>::init_with_good_format(const Matrix &B) {
     typedef typename linalg_traits<Matrix>::const_sub_col_type col_type;
-    if (pr) { delete[] pr; delete[] ir; delete[] jc; }
     nc = mat_ncols(B); nr = mat_nrows(B);
-    jc = new IND_TYPE[nc+1];
+    jc.resize(nc+1);
     jc[0] = shift;
     for (size_type j = 0; j < nc; ++j) {
-      jc[j+1] = jc[j] + nnz(mat_const_col(B, j));
+      jc[j+1] = IND_TYPE(jc[j] + nnz(mat_const_col(B, j)));
     }
-    pr = new T[jc[nc]];
-    ir = new IND_TYPE[jc[nc]];
+    pr.resize(jc[nc]);
+    ir.resize(jc[nc]);
     for (size_type j = 0; j < nc; ++j) {
       col_type col = mat_const_col(B, j);
-      typename linalg_traits<col_type>::const_iterator
-	it = vect_const_begin(col), ite = vect_const_end(col);
-      for (size_type k = 0; it != ite; ++it, ++k)
-	{ pr[jc[j]-shift+k] = *it; ir[jc[j]-shift+k] = it.index() + shift; }
+      typename linalg_traits<typename org_type<col_type>::t>::const_iterator
+        it = vect_const_begin(col), ite = vect_const_end(col);
+      for (size_type k = 0; it != ite; ++it, ++k) {
+        pr[jc[j]-shift+k] = *it;
+        ir[jc[j]-shift+k] = IND_TYPE(it.index() + shift);
+      }
     }
   }
-  
-  template <typename T, int shift> template <typename Matrix>
-  void csc_matrix<T, shift>::init_with(const Matrix &A) {
+
+  template <typename T, typename IND_TYPE, int shift>
+  template <typename Matrix>
+  void csc_matrix<T, IND_TYPE, shift>::init_with(const Matrix &A) {
     col_matrix<wsvector<T> > B(mat_nrows(A), mat_ncols(A));
     copy(A, B);
     init_with_good_format(B);
   }
-  
-  template <typename T, int shift>
-  void csc_matrix<T, shift>::init_with_identity(size_type n) {
-    if (pr) { delete[] pr; delete[] ir; delete[] jc; }
-    nc = nr = n; 
-    pr = new T[nc];
-    ir = new IND_TYPE[nc];
-    jc = new IND_TYPE[nc+1];
+
+  template <typename T, typename IND_TYPE, int shift>
+  void csc_matrix<T, IND_TYPE, shift>::init_with_identity(size_type n) {
+    nc = nr = n;
+    pr.resize(nc); ir.resize(nc); jc.resize(nc+1);
     for (size_type j = 0; j < nc; ++j)
       { ir[j] = jc[j] = shift + j; pr[j] = T(1); }
     jc[nc] = shift + nc;
   }
-  
-  template <typename T, int shift>
-  csc_matrix<T, shift>::csc_matrix(size_type nnr, size_type nnc)
+
+  template <typename T, typename IND_TYPE, int shift>
+  csc_matrix<T, IND_TYPE, shift>::csc_matrix(size_type nnr, size_type nnc)
     : nc(nnc), nr(nnr) {
-    pr = new T[1];  ir = new IND_TYPE[1];
-    jc = new IND_TYPE[nc+1];
+    pr.resize(1);  ir.resize(1); jc.resize(nc+1);
     for (size_type j = 0; j <= nc; ++j) jc[j] = shift;
   }
 
-  template <typename T, int shift>
-  struct linalg_traits<csc_matrix<T, shift> > {
-    typedef csc_matrix<T, shift> this_type;
-    typedef typename this_type::IND_TYPE IND_TYPE;
+  template <typename T, typename IND_TYPE, int shift>
+  struct linalg_traits<csc_matrix<T, IND_TYPE, shift> > {
+    typedef csc_matrix<T, IND_TYPE, shift> this_type;
     typedef linalg_const is_reference;
     typedef abstract_matrix linalg_type;
     typedef T value_type;
@@ -585,7 +600,7 @@ namespace gmm
     typedef cs_vector_ref<const T *, const IND_TYPE *, shift>
     const_sub_col_type;
     typedef sparse_compressed_iterator<const T *, const IND_TYPE *,
-				       const IND_TYPE *, shift>
+                                       const IND_TYPE *, shift>
     const_col_iterator;
     typedef abstract_null_type col_iterator;
     typedef col_major sub_orientation;
@@ -593,47 +608,47 @@ namespace gmm
     static size_type nrows(const this_type &m) { return m.nrows(); }
     static size_type ncols(const this_type &m) { return m.ncols(); }
     static const_col_iterator col_begin(const this_type &m)
-    { return const_col_iterator(m.pr, m.ir, m.jc, m.nr, m.pr); }
-    static const_col_iterator col_end(const this_type &m)
-    { return const_col_iterator(m.pr, m.ir, m.jc + m.nc, m.nr, m.pr); }
+    { return const_col_iterator(&m.pr[0],&m.ir[0],&m.jc[0], m.nr, &m.pr[0]); }
+    static const_col_iterator col_end(const this_type &m) {
+      return const_col_iterator(&m.pr[0],&m.ir[0],&m.jc[0]+m.nc,
+                                m.nr,&m.pr[0]);
+    }
     static const_sub_col_type col(const const_col_iterator &it) {
       return const_sub_col_type(it.pr + *(it.jc) - shift,
-				it.ir + *(it.jc) - shift,
-				*(it.jc + 1) - *(it.jc), it.n);
+                                it.ir + *(it.jc) - shift,
+                                *(it.jc + 1) - *(it.jc), it.n);
     }
-    static const origin_type* origin(const this_type &m) { return m.pr; }
+    static const origin_type* origin(const this_type &m) { return &m.pr[0]; }
     static void do_clear(this_type &m) { m.do_clear(); }
     static value_type access(const const_col_iterator &itcol, size_type j)
     { return col(itcol)[j]; }
   };
 
-  template <typename T, int shift>
+  template <typename T, typename IND_TYPE, int shift>
   std::ostream &operator <<
-    (std::ostream &o, const csc_matrix<T, shift>& m)
+    (std::ostream &o, const csc_matrix<T, IND_TYPE, shift>& m)
   { gmm::write(o,m); return o; }
-  
-  template <typename T, int shift>
-  inline void copy(const identity_matrix &, csc_matrix<T, shift>& M)
+
+  template <typename T, typename IND_TYPE, int shift>
+  inline void copy(const identity_matrix &, csc_matrix<T, IND_TYPE, shift>& M)
   { M.init_with_identity(mat_nrows(M)); }
 
-  template <typename Matrix, typename T, int shift>
-  inline void copy(const Matrix &A, csc_matrix<T, shift>& M)
+  template <typename Matrix, typename T, typename IND_TYPE, int shift>
+  inline void copy(const Matrix &A, csc_matrix<T, IND_TYPE, shift>& M)
   { M.init_with(A); }
 
   /* ******************************************************************** */
   /*                                                                      */
-  /*	        Read only compressed sparse row matrix                    */
+  /*             Read only compressed sparse row matrix                   */
   /*                                                                      */
   /* ******************************************************************** */
 
-  template <typename T, int shift = 0>
+  template <typename T, typename IND_TYPE = unsigned int, int shift = 0>
   struct csr_matrix {
 
-    typedef unsigned int IND_TYPE;
-
-    T *pr;        // values.
-    IND_TYPE *ir; // col indices.
-    IND_TYPE *jc; // row repartition on pr and ir.
+    std::vector<T> pr;        // values.
+    std::vector<IND_TYPE> ir; // col indices.
+    std::vector<IND_TYPE> jc; // row repartition on pr and ir.
     size_type nc, nr;
 
     typedef T value_type;
